<?php
// $Id$
/**
 * @file field_convert.admin.inc
 * Contains page callbacks for the module.
 */

/**
 * Form generator for the migration selection form.
 */
function field_convert_select($form, &$form_state) {
  $conversion_plans = _field_convert_get_plans();
  
  $options = array();
  
  /*
  $form['plans'] = array(
    '#tree' => TRUE,
    '#type' => 'value'
  );
  */
  $form['#tree'] = TRUE;
  
  /*
  $form['plans'] = array(
    '#type' => 'markup',
    '#markup'  => 'fdfd',
  );
  */
  
  foreach ($conversion_plans as $key => $plan) {
    $form['plans'][$key] = array(
      '#plan'         => $plan,
      '#type'         => 'checkbox',
      '#title'        => $plan['title'],
      '#description'  => $plan['description'],
    );
    if (isset($plan['disabled'])) {
      $form['plans'][$key]['#disabled'] = TRUE;
      $form['plans'][$key]['#description'] .= '<br />' . 
        t('This plan requires @modules.', array('@modules' => 'blah'));
    }
  }
  
  //dsm($form);
  //dsm($options);
  
  /*
  $form['plans'] = array(
    '#type' => 'radios',
    '#options' => $options,
    '#description' => t('hi'),
    '#title' => t('Select a plan'),
  );
  
  */
  
  $form['submit'] = array(
    '#type' => 'submit', 
    '#value' => t('Process')
  );
  
  
  // test stuff
  /*
  foreach ($conversion_plans as $key => $plan) {
    switch ($plan['list']['query_method']) {
      case 'dynamic':
        // this is the only case we handle so far! todo! 
        
        // Get the base table and its abbreviation as the first letter,
        // eg 'node', 'n'
        $base_table = $plan['list']['query']['base'];
        $base_abbrev = substr($base_table, 0, 1);
        
        $query = db_select($base_table, $base_abbrev);
        // Add the fields
        call_user_func_array(array($query, 'fields'), array($base_abbrev, $plan['list']['query']['fields']));
        // Add the conditions
        foreach ($plan['list']['query']['conditions'] as $condition) {
          // does the same as $query->condition('n.type', 'article', '=')
          call_user_func_array(array($query, 'condition'), $condition);
        }
        // the range
        $query->range(0, 10);
        $result = $query->execute();
        $objects_ids = $result->fetchCol();
        dsm($objects_ids);
    }
    
    switch ($plan['load']['load_method']) {
      // @todo: support other load methods.
      case 'entity':
        $objects = entity_load(
          $plan['object_type'], 
          $objects_ids, 
          isset($plan['load']['conditions']) ? $plan['load']['conditions'] : array()
        );
        
        //dsm($objects);

    }

    foreach ($objects as $object) {
      image_attach_migrate_pre_process($object);
      dsm($object);
      
      $language = 'und'; // @todo: support multilingual in ways I've no idea about.
      foreach ($plan['manipulate']['property_conversions'] as $key => $conversion) {
        if (!is_array($conversion)) {
          // If the conversion is a string, it's an 'old_property' => 'new_property' type conversion.
          $new_property = $conversion; // Just for variable name sanity.
          $old_property = $object->$key;
          if (is_array($old_property)) {
            // A multivalued field is assumed to go into a multivalued FieldAPI Field. (Dang that is harder to type than CCK!)
            foreach ($old_property as $value) {
              $object->{$new_property}[$language][] = array(
                'value' => $value,
              );
            }
          }
          else {
            $object->{$new_property}[$language][] = array(
              'value' => $old_property,
            );
          }
        }
      }
      
      dsm($object);
      
      
    }


  }
  */
  
  return $form;
}

/**
 * Submit handler.
 */
function field_convert_select_submit($form, &$form_state) {
  // start the batch
  
  //dsm($form_state['values']['plans']);
  //print_r($form_state);
  
  //drupal_set_message(t('Your configuration has been saved.'));
  
  $plans = array();
  foreach (array_filter($form_state['values']['plans']) as $plan_name => $status) {
    $plans[$plan_name] = $form['plans'][$plan_name]['#plan'];
  }
  
  //dsm($plans);
  
  foreach ($plans as $plan) {
    _field_convert_batch($plan);
    // Consecutive batches? see http://drupal.org/node/368742
  }
}

/**
 * Helper function to create a batch.
 */
function _field_convert_batch($plan) {
  // TODO: sanity checks:
  // - objects and object types exist
  // - new fields don't exist
  // - existing fields exist
  // - modules exist
  
  $batch = array(
    'title' => t('Migrating data'),
    'file'  => drupal_get_path('module', 'field_convert') . '/field_convert.admin.inc',
    'operations' => array(
      // Each operation is an array of callback and arguments.
      array('_field_convert_batch_process_create_fields', array($plan)),
      array('_field_convert_batch_process_migrate_data', array($plan)),
    ),
    'finished' => "batch_example_finished",
    'init_message' => t("Example Batch $plan is starting."),
    'progress_message' => t('Processed @current out of @total.'),
    'error_message' => t('Example Batch has encountered an error.'),
  );
  batch_set($batch);

  // If this function was called from a form submit handler, stop here,
  // FAPI will handle calling batch_process().

}

/**
 * Batch operation callback to create fields.
 */
function _field_convert_batch_process_create_fields($plan) {
  if (isset($plan['files'])) {
    foreach ($plan['files'] as $file) {
      include_once($file);
    }
  }
  
  foreach ($plan['fields'] as $field_name => $field_data) {
    switch ($field_data['status']) {
      case 'create':
        $context['message'] = "creating field $field_name";
        watchdog('field convert', "created field $field_name");
        
        // Create the field
        $field = array(
          'field_name'  => $field_name, // We assume the data knows what it is doing 
            // and suitable module name prefixes are in place!
          'type'        => $field_data['type'],
          'cardinality' => $field_data['cardinality'],
        );
        field_create_field($field);
        
        // Create the instance
        foreach ($field_data['bundles'] as $bundle) {
          $instance = array(
            'field_name'  => $field_name, 
            'object_type' => $field_data['object_type'],
            'bundle'      => $bundle,
            'label'       => $field_data['label'],
            'description' => $field_data['description'],
            'widget'      => $field_data['widget'],
          );
          field_create_instance($instance);
        }
        
        break;
      
      // @TODO: other cases. probably fallthrough instance creation eg.  
    }
  }
  
  $context['finished'] = TRUE;
} 

/**
 * Batch operation callback.
 */
function _field_convert_batch_process_migrate_data($plan) {
  if (isset($plan['files'])) {
    foreach ($plan['files'] as $file) {
      include_once($file);
    }
  }

  if (!isset($context['sandbox']['progress'])) {
    $context['sandbox']['progress'] = 0;
    $context['sandbox']['current_object'] = 0;
    // @todo $context['sandbox']['max'] = db_result(db_query('SELECT COUNT(DISTINCT nid) FROM {node}'));
  }  
  
  // For this example, we decide that we can safely process
  // 5 nodes at a time without a timeout.
  $limit = 5;  
  
  // With each pass through the callback, retrieve the next group of object ids.
  switch ($plan['list']['query_method']) {
    case 'dynamic':
      // @todo: This is the only case we handle so far!
      
      // Get the base table and its abbreviation as the first letter, eg 'node', 'n'.
      $base_table = $plan['list']['query']['base'];
      $base_abbrev = substr($base_table, 0, 1);
      
      $query = db_select($base_table, $base_abbrev);
      // Add the fields.
      call_user_func_array(array($query, 'fields'), array($base_abbrev, $plan['list']['query']['fields']));
      // Add the conditions.
      foreach ($plan['list']['query']['conditions'] as $condition) {
        // does the same as $query->condition('n.type', 'article', '=')
        call_user_func_array(array($query, 'condition'), $condition);
      }
      // Set the range.
      $query->range(0, $limit);
      $result = $query->execute();
      $objects_ids = $result->fetchCol();
      //dsm($objects_ids);
      break;
  }
  
  // Load the objects for this batch.
  switch ($plan['load']['load_method']) {
    // @todo: support other load methods.
    case 'entity':
      $objects = entity_load(
        $plan['object_type'], 
        $objects_ids, 
        isset($plan['load']['conditions']) ? $plan['load']['conditions'] : array()
      );
      break;
  }

  // Manipulate each object.
  $save_function = $plan['save'];
  foreach ($objects as $object) {
    // @TODO: sort out messages and logging.
    $context['results'][] = $object->nid . ' : ' . $object->title;
    $context['message'] = $object->title;  
    
    // Call the preprocess callback if there is one.
    if (isset($plan['manipulate']['pre_process'])) {
      $pre_process_function = $plan['manipulate']['pre_process'];
      $pre_process_function($object);
    }

    // Migrate the property values.
    $language = 'und'; // @todo: support multilingual in ways I've no idea about.
    foreach ($plan['manipulate']['property_conversions'] as $key => $conversion) {
      if (!is_array($conversion)) {
        // If the conversion is a string, it's an 'old_property' => 'new_property' type conversion.
        // Not all objects might have this property; eg with taxonomy terms,
        // this node may be of a type that doesn't have all vocabs and so we do nothing
        // for this particular conversion.
        if (isset($object->$key)) {
          $new_property = $conversion; // Just for variable name sanity.
          $old_property = $object->$key;
          if (is_array($old_property)) {
            // A multivalued field is assumed to go into a multivalued FieldAPI Field. (Dang that is harder to type than CCK!)
            foreach ($old_property as $value) {
              $object->{$new_property}[$language][] = array(
                'value' => $value,
              );
            }
          }
          else {
            $object->{$new_property}[$language][] = array(
              'value' => $old_property,
            );
          }
        }
      }
      // @todo: Next case: the conversion is an array with processor callback etc
      // @todo: define how these work.
    }
    
    // Save the object.
    $save_function($object);
    
  }
}

/** 
 * Helper function to get all conversion plans and process them for sanity.
 */
function _field_convert_get_plans() {
  // ARGH! module_load_all_includes('inc', 'field_convert');
  module_load_include('inc', 'field_convert', 'taxonomy.field_convert'); // hack
  
  $conversion_plans = module_invoke_all('field_convert_info');
  
  //dsm($conversion_plans);
  
  // Check each plan has all the modules it needs.
  foreach ($conversion_plans as $key => $plan) {
    foreach ($plan['dependencies'] as $module) {
      if (!module_exists($module)) {
        $conversion_plans[$key]['disabled'] = TRUE;
        // can now pop out if I could be bothered to figure out how to do it
        // in PHP and not get it wrong.
      }
    }
  }
  
  //dsm($conversion_plans);
  
  return $conversion_plans;
}

