<?php
// $Id$
/**
 * @file 
 * Plan for taxonomy module. WARNING: NOT TESTED YET!
 * See end of file for test data to use on a fresh D7 install.
 */

/**
 * Implement hook_field_convert_info().
 *
 * Return an array describing field migration plans.
 *
 * INCOMPLETE implementation for taxonomy.
 */ 
function taxonomy_field_convert_info() {
  /**
    I am assuming that:
      - the old data is still there
      - the data about individual vocabs and terms has been copied over to new tables
      - this is quite probably inconsistent - we should probably query {taxonomy_vocabulary} instead!!!
        however we need {vocabulary_node_types} around for now.
        and {term_node}
   */
  
  $taxonomy_plan = array(
    // Basics about this field migration plan
    'title' => t('Taxonomy'),
    'description' => t('DEMO: taxonomy. NOT READY YET.'),
    'dependencies' => array(
      // array of modules:
      'taxonomy',
    ),
    'files' => array(
      // array of files to include
     __FILE__,
    ),
    'object_type' => 'node', // gah is there a diff between 'entity' and 'object'?
    
    'fields' => array(), // fill this in further down
    
    // How to get all the objects we need to operate on
    'list' => array(
      'query_method' => 'dynamic', // DBTNG baby! todo: support static queries too?
      'query' => array(
        // this is an array of stuff to build the query object with
        'base' => 'node', // todo: only give this if not the same string as object type.
        // we'll use the standard abbreviation of the first letter of this!
        'conditions' => array(
          // arrays of parameters suitable for passing to the $query as conditions
          // each array here is passed as $query->([the array])
          // no conditions: we load all nodes!
        ),
        'fields' => array('nid'), // you need only retrieve here what your loader needs, so just the ID field probably.
      ),
    ),
    
    // How to load each object we manipulate.
    'load' => array(
      'load_method' => 'entity', 
      // can be one of:
      // - entity: use the core entity_load() function. In which case, specify 'conditions' to pass.
      // - callback: use your own function. specify the 'load_callback' and 'load_arguments'
      // - query: specify a query in 'query'. eg:
      // 'query' => "SELECT nid FROM {node} WHERE nid > %d AND type = 'article' ORDER BY nid ASC",
      // the query that loads us the objects we need
    ),

    'manipulate' => array(
      'pre_process' => 'taxonomy_migrate_pre_process', // todo: consider making this an automatic function eg PLAN_preprocess?
      // optional callback to run before manipulation. Use this to fetch data into the objcet, tidy it up, move files, etc.
      // this function should hav signature my_preprocess(&$object). You should put extra data into the $object
      // but be sure to use safe property names, eg 'migrate_PLAN_NAME'.
      'property_conversions' => array(), // this is filled in lower down
      // 'post_process' => optional callback to run after manipulation. Use this to tidy up data, move files, etc.
    ),
    
    // How to save the entity once we are done.
    'save' => 'node_save',

  );
  
  // @todo: tidy up these queries!
  $result = db_query('SELECT v.vid, n.type FROM {vocabulary} v LEFT JOIN {vocabulary_node_types} n ON v.vid = n.vid');
  $vocabulary_node_types = $result->fetchAll(PDO::FETCH_ASSOC);
  
  $result = db_query('SELECT * FROM {vocabulary}');
  $vocabularies = $result->fetchAllAssoc('vid');
  
  // Add the node types to each vocabulary as an array.
  foreach ($vocabulary_node_types as $data) {
    $vocabularies[$data['vid']]->node_types[] = $data['type'];
  }

  //dsm($vocabularies);

  // For each vocabulary, we must create a field that is instanced on all the types for that vocab.
  $taxonomy_plan['fields'] = array();
  
  foreach ($vocabularies as $vocabulary) {
    $field_name = 'taxonomy_vocabulary_' . $vocabulary->vid;
    /*
    possible widget types:
      - taxonomy_autocomplete: if tags
      - options_buttons: if multiselect and not tags
      - options_select: otherwise
    */
    if ($vocabulary->tags) {
      $widget_type = 'taxonomy_autocomplete';
    }
    elseif ($vocabulary->multiple) {
      $widget_type = 'options_buttons';
    }
    else {
      $widget_type = 'options_select';
    }
    
    $taxonomy_plan['fields'][$field_name] = array(
      'status'      => 'create', 
      // whether this is a new field to create, a new instance of an existing field, or an existing instance.
      // Following keys are standard FieldAPI: @see <http://drupal.org/node/474420>.
      'type' => 'taxonomy_term_reference',
      // Some useful information: $field_type_options = field_ui_field_type_options();
      'cardinality' => $vocabulary->multiple ? FIELD_CARDINALITY_UNLIMITED : 1,
      'object_type' => 'node',   // @todo: read this from the top level? will we ever need fields on more than one type? 
      'bundles' => $vocabulary->node_types,
      'label' =>   $vocabulary->name,
      'description' => $vocabulary->description,
      
      // @todo! all the data stuff for the field -- serialized stuff
      // INCLUDING which vocab this field actually is!!!
      //  settings[allowed_values][] = array( vid => $vid, parent => no idea!)
      
      
      'widget' => array(
        'type' => $widget_type,
        // Some useful information: include_once('modules/field_ui/field_ui.admin.inc'); $widget_type_options = field_ui_widget_type_options(NULL, TRUE); dsm($widget_type_options);
        'weight' => 10,
      ),
    );
    
    // Manipulations.
    // The idea here is to let the API do part of the work: it know how to handle fieldAPI stuff
    // However, we come in with 
    $taxonomy_plan['manipulate']['property_conversions']['term_node_' . $vocabulary->vid] = $field_name;
    // WRITE ME! we need a processor here to get all the terms out of $node->taxonomy and into the respective fields!  
    /*
            // An array of property conversions.
        // Simple version:
        // 'old_property' => 'new_property'
        // take data from old_property and put it into new_property. 
        // if 'old_property' is an array, each value is taken to be a value for a multi-valued field.
        // (you DID define your field as multivalued, yes?)
        // new_property should be the base property for the FieldAPI field. The system will take care of the array
        // structure beneath this.
        'article_custom_field' => 'article_number',
        // for taxonomy: need one conversion for each vocabulary.
        
        // @todo: think about what more complex cases might need: a callback, for instance
        // in which case the key is just a key, and the value is an array of stuff.
*/
    
  }
  
    /*
    
    
    // How to manipulate each object: take values from one property and put them in another.
    // write me
    'manipulate' => array(
      'pre_process' => 'taxonomy_migrate_pre_process', // todo: consider making this an automatic function eg PLAN_preprocess?
      // optional callback to run before manipulation. Use this to fetch data into the objcet, tidy it up, move files, etc.
      // this function should hav signature my_preprocess(&$object). You should put extra data into the $object
      // but be sure to use safe property names, eg 'migrate_PLAN_NAME'.
      'property_conversions' => array(
        // An array of property conversions.
        // Simple version:
        // 'old_property' => 'new_property'
        // take data from old_property and put it into new_property. 
        // if 'old_property' is an array, each value is taken to be a value for a multi-valued field.
        // (you DID define your field as multivalued, yes?)
        // new_property should be the base property for the FieldAPI field. The system will take care of the array
        // structure beneath this.
        'article_custom_field' => 'article_number',
        // for taxonomy: need one conversion for each vocabulary.
        
        // @todo: think about what more complex cases might need: a callback, for instance
        // in which case the key is just a key, and the value is an array of stuff.
      ),
      // 'post_process' => optional callback to run after manipulation. Use this to tidy up data, move files, etc.
    ),
    
  );
  */

  return array(
    'taxonomy_term' => $taxonomy_plan,
  );  
}

/**
 * Pre_process function for the taxonomy plan
 */
function taxonomy_migrate_pre_process(&$object) {
  // There is (I assume) no longer any code to load from {term_node}
  // so we have to do it ourselves here.
  $result = db_query("SELECT * FROM {term_node} tn JOIN {term_data} WHERE tn.nid = :nid", array(':nid' => $object->nid));
  foreach ($result as $record) {
    // Load just the tids into a dummy property on the object, so the core API can do its work with FieldAPI
    // cardinality and language and all that malarkey.
    $object->{'term_node_' . $record->vid}[] = $record->tid;
  }
}

/*
Some test data for testing upgrading taxonomy

CREATE TABLE IF NOT EXISTS `vocabulary` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `description` longtext,
  `help` varchar(255) NOT NULL DEFAULT '',
  `relations` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `multiple` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `required` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `tags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `module` varchar(255) NOT NULL DEFAULT '',
  `weight` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`vid`),
  KEY `list` (`weight`,`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

--
-- Dumping data for table `vocabulary`
--

INSERT INTO `vocabulary` VALUES(1, 'Tags', '', '', 1, 0, 0, 0, 1, 'taxonomy', 0);
INSERT INTO `vocabulary` VALUES(2, 'Region', '', '', 1, 1, 1, 0, 0, 'taxonomy', -7);
INSERT INTO `vocabulary` VALUES(3, 'Floopiness', '', '', 1, 0, 0, 0, 0, 'nodeorder', -10);

-- --------------------------------------------------------

--
-- Table structure for table `vocabulary_node_types`
--

CREATE TABLE IF NOT EXISTS `vocabulary_node_types` (
  `vid` int(10) unsigned NOT NULL DEFAULT '0',
  `type` varchar(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`type`,`vid`),
  KEY `vid` (`vid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `vocabulary_node_types`
--

INSERT INTO `vocabulary_node_types` VALUES(2, 'page');
INSERT INTO `vocabulary_node_types` VALUES(3, 'page');
INSERT INTO `vocabulary_node_types` VALUES(1, 'story');
INSERT INTO `vocabulary_node_types` VALUES(2, 'story');   
*/
